<?
#input $_GET['id_espacio_sgu']
#output rutas: [ ...ruta, salones: [{...salon}] ]
header('Content-Type: application/json charset=utf-8');
ini_set('memory_limit', '2048M');
ini_set('post_max_size', '2048M');
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

$ruta = "..";
require_once "$ruta/class/c_login.php";
if (!isset($_SESSION['user'])) {
    http_response_code(401);
    die(json_encode(['error' => 'unauthorized']));
}
$user = unserialize($_SESSION['user']);

// check method
try {
    if ($_SERVER['REQUEST_METHOD'] === 'GET') {
        /* $db->query(<<<SQL
            REFRESH MATERIALIZED VIEW CONCURRENTLY PUBLIC.AUDITORIA_MAT
            SQL
        ); */
        // pg_send_query($db->getConnection(), "REFRESH MATERIALIZED VIEW CONCURRENTLY PUBLIC.AUDITORIA_MAT");
        $baseDate = $_GET['fecha'] ?? $_GET['fecha_fin'] ?? null;

        $params = [
            // ':periodo_id' => $_GET['periodo_id'] > 0 ? $user->periodo_id : null,
            ':facultad_id' => $user->facultad['facultad_id'],
            ':fecha_inicio' => $_GET['fecha'] ?? $_GET['fecha_inicio'] ?? date('Y-m-d'),
            ':fecha_fin' => $baseDate ? date('Y-m-d H:i:s', strtotime("$baseDate +24 hours")) : date('Y-m-d H:i:s'),
            'usuario_id' => $user->user['id'],
        ];
        $data = $db->query(
            "WITH AUDITORIA_DATA AS (
                SELECT * FROM PUBLIC.AUDITORIA_MAT
                WHERE FACULTAD_ID = COALESCE(:facultad_id, FACULTAD_ID)
                AND REGISTRO_FECHA_IDEAL + HORARIO_HORA between :fecha_inicio AND  :fecha_fin
            ), DELETION AS (
                DELETE FROM last_auditoria
                WHERE usuario_id = :usuario_id
            ), INSERTION AS (
                INSERT INTO last_auditoria
                SELECT :usuario_id, to_jsonb(AUDITORIA_DATA), registro_fecha_ideal, horario_id, profesor_id FROM AUDITORIA_DATA
                WHERE REGISTRO_FECHA_IDEAL IS NOT NULL
            )
            SELECT 
                registro_id,
                registro_fecha_ideal,
                horario_id,
                profesor_id,
                salon,
                profesor_clave,
                profesor_nombre,
                horario_hora,
                horario_fin,
                registro_fecha,
                color,
                estado_color,
                estado_icon,
                estado_supervisor_id,
                facultad_id,
                usuario_nombre,
                registro_fecha_supervisor,
                comentario,
                registro_justificada,
                justificacion,
                reposicion_id
             FROM AUDITORIA_DATA ORDER BY registro_fecha_ideal, horario_hora",
            $params
        );
        // Print the JSON file
        echo json_encode($data);
    } else {
        http_response_code(405);
        echo json_encode(['error' => 'method not allowed']);
        exit;
    }
} catch (PDOException $th) {
    http_response_code(500);
    echo json_encode([
        'error' => $th->getMessage(),
        // 'query' => $db->getLastQuery(),
    ], JSON_UNESCAPED_UNICODE | JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES | JSON_PARTIAL_OUTPUT_ON_ERROR);
    exit;
} catch (Exception $th) {
    http_response_code(500);
    echo json_encode([
        'error' => $th->getMessage(),
    ], JSON_UNESCAPED_UNICODE | JSON_PRETTY_PRINT);
    exit;
}